require 'sketchup.rb'
module MSketchyPhysics3

class ControllerContext
    def initialize
        @vars=Hash.new
        @namedGroups=Hash.new
    end
    def slider(sname,defaultValue=0.5,min=0.0,max=1.0)
        return defaultValue if($controlSliders==nil)
        if($controlSliders[sname]==nil)
            MSketchyPhysics3::createController(sname,defaultValue,min,max)   
          end
          $controlSliders[sname].value
        return $controlSliders[sname].value    
    end
    def setVar(name,value)
        @vars[name]=value    
    end
    def getVar(name)
        return 0.0 if(@vars[name]==nil)
        return @vars[name]    
    end
    def getSetVar(name,value=0)
        return 0.0 if(@vars[name]==nil)
        v= @vars[name]
        @vars[name]=value
        return v        
    end    
    
    def key(k)
        k=KeyNames[k.upcase]
        return (1.0) if (k!=nil && getKeyState(k) )
        return(0.0)
    end
    def playsound(name)
        fn=Sketchup.find_support_file(name, "plugins/SketchyPhysics3/sounds/cache")
        if(fn==nil)
            fn=Sketchup.find_support_file(name, "plugins/SketchyPhysics3/sounds/")    
        end
        UI.play_sound(fn) if(fn!=nil)
    end
    def joy(name)
        name.downcase!
        deadzone=100
        case name
            when "leftx"
                if(@joystate.lX.abs>deadzone)
                    return (@joystate.lX/2000.0)+0.5
                else
                    return 0.5+(getKeyState(VK_D)?0.5:0.0)+(getKeyState(VK_A)?-0.5:0.0)
                end                    
            when "lefty"
                if(@joystate.lY.abs>deadzone)
                    return (@joystate.lY/2000.0)+0.5
                else
                    return 0.5+(getKeyState(VK_S)?0.5:0.0)+(getKeyState(VK_W)?-0.5:0.0)
                end                    
            when "rightx"
                if(@joystate.lRx.abs>deadzone)
                    return (@joystate.lRx/2000.0)+0.5
                else
                    return 0.5+(getKeyState(VK_RIGHT)?0.5:0.0)+(getKeyState(VK_LEFT)?-0.5:0.0)
                end                    
            when "righty"
                if(@joystate.lRy.abs>deadzone)
                    return (@joystate.lRy/2000.0)+0.5
                else
                    return 0.5+(getKeyState(VK_DOWN)?0.5:0.0)+(getKeyState(VK_UP)?-0.5:0.0)
                end                    
        end
        return(0.5)
    end

	
    @@joyButtonMapping=Hash["a",0,"b",1,"x",2,"y",3,"lb",4,"rb",5,"back",6,"start",7,"leftb",8,"rightb",9]
    def joybutton(name)
        v=@@joyButtonMapping[name.downcase]
        return @joystate.rgbButtons[v]/-128 if v!=nil
        return 0
    end
	
	def joybutton(name)
        name.downcase!
        deadzone=100
        case name
            when "a"
                if(@joystate.rgbButtons[0].abs>deadzone)
                    return (@joystate.rgbButtons[0]/-128)
                else
                    return (getKeyState(VK_NUMPAD4)?1:0.0)
                end
            when "b"
                if(@joystate.rgbButtons[1].abs>deadzone)
                    return (@joystate.rgbButtons[1]/-128)
                else
                    return (getKeyState(VK_NUMPAD7)?1:0.0)
                end
            when "x"
                if(@joystate.rgbButtons[2].abs>deadzone)
                    return (@joystate.rgbButtons[2]/-128)
                else
                    return (getKeyState(VK_NUMPAD8)?1:0.0)
                end
            when "y"
                if(@joystate.rgbButtons[3].abs>deadzone)
                    return (@joystate.rgbButtons[3]/-128)
                else
                    return (getKeyState(VK_NUMPAD9)?1:0.0)
                end 
            when "lb"
                if(@joystate.rgbButtons[4].abs>deadzone)
                    return (@joystate.rgbButtons[4]/-128)
                else
                    return (getKeyState(VK_NUMPAD0)?1:0.0)
                end
            when "rb"
                if(@joystate.rgbButtons[5].abs>deadzone)
                    return (@joystate.rgbButtons[5]/-128)
                else
                    return (getKeyState(VK_NUMPAD6)?1:0.0)
                end
            when "back"
                if(@joystate.rgbButtons[6].abs>deadzone)
                    return (@joystate.rgbButtons[6]/-128)
                else
                    return (getKeyState(VK_SUBTRACT)?1:0.0)
                end
            when "start"
                if(@joystate.rgbButtons[7].abs>deadzone)
                    return (@joystate.rgbButtons[7]/-128)
                else
                    return (getKeyState(VK_ADD)?1:0.0)
                end
            when "leftb"
                if(@joystate.rgbButtons[8].abs>deadzone)
                    return (@joystate.rgbButtons[8]/-128)
                else
                    return (getKeyState(VK_SEPARATOR)?1:0.0)
                end
            when "rightb"
                if(@joystate.rgbButtons[9].abs>deadzone)
                    return (@joystate.rgbButtons[9]/-128)
                else
                    return (getKeyState(VK_MULTIPLY)?1:0.0)
                end
         end
    end 
	def joyRX()
		deadzone=100
				if(@joystate.lRz.abs>deadzone)
                    return 0.5+(@joystate.lRz/2000.0)
                else
                    return 0.5+(getKeyState(VK_NUMPAD3)?0.5:0.0)+(getKeyState(VK_NUMPAD1)?-0.5:0.0)
                end
	end
	def joyRY()
		deadzone=100      
				if(@joystate.lZ.abs>deadzone)
                    return 0.5+(@joystate.lZ/2000.0)
                else
                    return 0.5+(getKeyState(VK_NUMPAD2)?0.5:0.0)+(getKeyState(VK_NUMPAD5)?-0.5:0.0)
                end
	end
	
    #mousecursorloc?
    def vectorTo(name)
        
    end
    
    def sample(array,rate=1)
        v=array[(frame/rate)]
        return v if(v.class==Fixnum or v.class==Float)
        return 0
    end
    def oscillator(rate)
        inc=(2*3.141592)/rate
        pos=Math.sin(inc*(@frame))
        return (pos/2.0)+0.5
    end
    def body(name)
        #return body
    end
    def setCamera
        return if($sketchyPhysicsToolInstance==nil || $curEvalGroup==nil)
        xform=$curEvalGroup.transformation
        Sketchup.active_model.active_view.camera.set(xform.origin, xform.zaxis, [0,0,1])
    end

    
    def lookAt(target,stiff=10.0,damp=10.0)
            #if simulation isnt running then we are verifying
        if $sketchyPhysicsToolInstance==nil
            return
        end
        #get this grp.
        grp=$curEvalGroup
        xform=grp.transformation
        body=DL::PtrData.new(grp.get_attribute("SPOBJ","body",nil))

        #see if this already has a lookAtJoint
        jnt=grp.get_attribute("SPOBJ","__lookAtJoint",nil)
        if(jnt==nil)
            #create gyro and attach to the body.
            puts "creating lookat joint"
            limits=[0,0,stiff,damp]
            pinDir=xform.zaxis.to_a
            jnt=NewtonServer.createJoint("gyro",xform.origin.to_a.pack("f*"),
                pinDir.pack("f*"),
                body,nil, 
                limits.pack("f*") 
            )
                #this type of body cant freeze.
                #Hack! to force unfreeze of body
                NewtonServer.setBodyMagnetic(body,1)
                NewtonServer.setBodyMagnetic(body,0)
                #hack!         
            if(jnt!=0)
                grp.set_attribute("SPOBJ","__lookAtJoint",jnt.to_i) 
            end              
        end
        #find target.
        if target.is_a?(Array)
            pinDir=xform.origin.vector_to(target).to_a
        else
            #calc vector to target.
            targetgrp=$sketchyPhysicsToolInstance.FindGroupNamed(target)
            return if(targetgrp==nil)
            pinDir=xform.origin.vector_to(targetgrp.transformation.origin).to_a
        end
            #set pin dir to vector.
        NewtonServer.setGyroPinDir(DL::PtrData.new(grp.get_attribute("SPOBJ","__lookAtJoint",0)),pinDir.pack("f*"));
        #puts pinDir.inspect
    end
    def every(count)
        1*(@frame%count)    
    end
    def kick(body,direction,speed)
    end
    def copy(pos=nil,kick=nil,lifetime=0)
        #body=$sketchyPhysicsToolInstance.FindBodyNamed(name)
        return if($sketchyPhysicsToolInstance==nil)
        pos=Geom::Transformation.new(pos) if(pos!=nil)
        grp=$sketchyPhysicsToolInstance.copyBody($curEvalGroup,pos,lifetime)
        
        $sketchyPhysicsToolInstance.pushBody(grp,kick) if kick!=nil
        return grp
        #puts $sketchyPhysicsToolInstance.FindBodyNamed(name)
        #return newBody
    end
    def push(kick=nil)
        return if($sketchyPhysicsToolInstance==nil)
        $sketchyPhysicsToolInstance.pushBody($curEvalGroup,kick) if kick!=nil        
    end
    def showConfigDialog()
        @controllerMapping={ "leftx" => "lX", "lefty" => "lY",
                                "rightx" => "lRx", "righty" => "lRy" }

        prompts = ["leftx","lefty", "rightx", "righty"]
        values = [@controllerMapping["leftx"],@controllerMapping["lefty"],
                  @controllerMapping["rightx"],@controllerMapping["righty"]]
        results =  inputbox(prompts, values, ["lX|lY|lRx|lRy"],"Input configuration.")
        
        if (!results)
            return
        else
    #        enabled,density, linearViscosity, angularViscosity,current[0],current[1],current[2]=results
        end
    end

    def getBinding(frame)
        @frame=frame
        @joystate=JoyInput.state

        #axis range from -1000 to 1000.
        #scale to 0.0 to 1.0.
        leftx=(@joystate.lX/2000.0)+0.5
        lefty=(@joystate.lY/2000.0)+0.5
        rightx=(@joystate.lRx/2000.0)+0.5
        righty=(@joystate.lRy/2000.0)+0.5
                
		a=(@joystate.rgbButtons[0]/-128)+(key('numpad4'))
        b=(@joystate.rgbButtons[1]/-128)+(key('numpad7'))
        x=(@joystate.rgbButtons[2]/-128)+(key('numpad8'))
        y=(@joystate.rgbButtons[3]/-128)+(key('numpad9'))       
        
        #keyboard emulation of joystick.
        #delta=0.05
        leftx=0.5+(getKeyState(VK_D)?0.5:0.0)+(getKeyState(VK_A)?-0.5:0.0) if(leftx>0.5-0.05 && leftx<0.5+0.05)
        lefty=0.5+(getKeyState(VK_S)?0.5:0.0)+(getKeyState(VK_W)?-0.5:0.0) if(lefty>0.5-0.05 && lefty<0.5+0.05)
        rightx=0.5+(getKeyState(VK_RIGHT)?0.5:0.0)+(getKeyState(VK_LEFT)?-0.5:0.0) if(rightx>0.5-0.05 && rightx<0.5+0.05)
        righty=0.5+(getKeyState(VK_DOWN)?0.5:0.0)+(getKeyState(VK_UP)?-0.5:0.0) if(righty>0.5-0.05 && righty<0.5+0.05)

        joyLX=leftx
        joyLY=lefty
		return binding
		
        
        #one of the triggers goes from 0 to 1000 the other 0 to -1000
        lt=state.lZ/1000.0
        rt=state.lRz/-1000.0

            #buttons are 0 when up and -128 when down (wierd huh?)    

        lb=state.rgbButtons[4]/-128
        rb=state.rgbButtons[5]/-128
        back=state.rgbButtons[6]/-128
        start=state.rgbButtons[7]/-128
        leftb=state.rgbButtons[8]/-128
        rightb=state.rgbButtons[9]/-128

            #dpad is wierd
        dup=state.rgdwPOV[0]
        ddown=state.rgdwPOV[0]
        dleft=state.rgdwPOV[0]
        dright=state.rgdwPOV[0]

                                       
        return binding #turn  local vars into a binding.

    end #createControllerBinding

end

#events
#  returns=time of next tick?
#onTouch(other), touching(other),unTouch(other)
#onInit,OnBegin,OnEnd
#onTick 
#onKey(key,state)

#contants 
#up/down/north/south/east/west.

#Commands
#setCamera
#moveTo
#setTarget
#toggleVar
#lookAt #pos or named target, up,
#turnTo() #name, or location
#

#turn()# rel amount. yaw pitc roll 
#face() #abs direction.
#thrust() #rel vector
#push() #abs vector
#teleport
#rotation=

#built at body creation time (usually start)
#flags
#ignore,frozen,static,noauto(?),magnetic,nocollision.
#magnet
#target,dest,up 


#accessors
#position,rotation,velocity,turnrates

#funcs
#copy,erase,push,
#attach,connect

#eventDefinition
#name
#enabled
#params[]
#codeString
#raise

#events
#touch,touched,untouched
#@contact (body,force,direction,material?)
#  
#@toucher==@touchingObject
#@touchingLastFrame[]
#@touchingThisFrame[]
#tick,timer
#start,end,create,destroy
#key,keyDown,keyUP
#button,joy
#click,drag,unclick
#onSetVar

#need to take the string of the event code and turn it into a function
#that function needs to be called in the context of the body.
#its not a class member function because all bodies will have there own 
#event code.

#physics class diagram
#simulation
    #bodies[]#hash to name and group
    #joints[]
    #forces[]
    #properties
        #frameRate
        #gravity
    #methods
        #createBody,destroyBody
        #connectBody
    #events
        #start,end
        #tick,timer
        #key,joystick
#body
    #properties
        #ignore,frozen,static,noautofreeze,magnetic,nocollision
        #?? staticmesh,showcollision ??
    #accessors
        #name,position,velocity,transformation,rotation,
        
    #events
        #start,end
        #tick,timer
        #key,joystick,
        #touch
        #click
#joint
    #properties
        #min,max,accel,damp,
        #desiredPosition
    #methods
    #events
        #onTick (for controller)
#shape
    #properties
    #methods
#contact
    #properties
    #methods
#force
    #properties
    #methods

#IDEA:observer model
#ontick observes @frame
#onkey observes keyboard state
#ontouch observes touching objects list.

#observable :value

#IDEA: What would a timeline looklike.
#variblename and and array of values one per frame.
#no interpolation at first.
#types once,repeat,reciprocate



def self.dounit()
    sim=SP3xSimulationContext.new(Sketchup.active_model) 
    sel=Sketchup.active_model.selection
    sel.each{|e|
        next if(e.class!=Sketchup::Group)    
        b=sim.createBody(e)
        b._setEvent("ontouch","puts @name+' touched'")
        b._setEvent("ontouching","puts @name+' touching'")
        b._setEvent("onuntouch","puts @name+' untouched'")
        b._setEvent("ontick","puts @name+' ticked'")
        b._setEvent("onstart","puts @name+' start'")
        b._setEvent("onend","puts @name+' end'")
    }
    return sim

end
class SP3xSimulationContext
    attr_reader :bodies
    attr_accessor :joints
    attr_accessor :frameRate
    attr_accessor :gravity
    attr_reader :frame
    #@forces[]
    

    #signals
    def doOnStart()
        @startListeners.each{|body|body.doOnStart()}
        return true
    end
    def doOnEnd()
        @bodies.each{|body|body.doOnEnd()}
        return true
    end
    def doOnTick(frame=0)
        @frame=frame
        @tickListeners.each{|body|body.doOnTick()}
        return true
    end
    def doOnKey()
        @keyListeners.each{|body|body.onkeyFunc.call()}
        return true
    end
    def doOnMouse(type,ent,x,y)
        #puts type
        @mouseListeners.each{|body|
            if(body.group==ent)
                body.doMouse(type,x,y)
                #return body
                
                if(body.dragable)
                    return false
                else
                    return true
                end
            end
        }
        return false
    end
    
    def doMouse(type,ent,x,y)
        puts [type,ent,x,y].inspect    
    end
    
    #called whenever two bodies collide.
    def doTouching(grp,grpTouching,force,pos)
        body=findBody(grp)
        @lastTouchingBody=findBody(grpTouching)
        if(body.touchable)
            body.handleTouching(@lastTouchingBody,force,pos)
        end
        return true
    end
    def doPreFrame()
        return true
    end
    def doPostFrame()
        #this is needed for untouch AND touch to work.
        @touchingListeners.each{|body|body.handleUntouching()} 

        @deferedTasks.each{|task|
            task.call()
            }
        @deferedTasks=[]
        return true
    end
    
    #events    
    attr_reader :onstartFunc
    attr_reader :onendFunc
    attr_reader :ontickFunc
    attr_reader :onkey
    attr_reader :onmouse
    
    #event listeners
    attr_reader :touchingListeners
    attr_reader :tickListeners,:startListeners,:endListeners
    attr_reader :keyListeners,:joyListeners
    attr_reader :timerListeners
    attr_reader :mouseListeners
    
    attr_reader :deferedTasks
        #temp helper function
    def uniqpush(array,value)
        array.push(value) if !array.include?(value)
    end  
    
    def unsubscribeAll(receiver)
        @startListeners.delete(receiver)
        @endListeners.delete(receiver)
        @touchingListeners.delete(receiver)
        @tickListeners.delete(receiver)
        @keyListeners.delete(receiver)
        @joyListeners.delete(receiver)
        @mouseListeners.delete(receiver)
    end
    def subscribeToEvent(name,receiver)
   
        case name
            when "onstart"
                uniqpush(@startListeners,receiver)
            when "onend"
                uniqpush(@endListeners,receiver)
            when "ontouching","ontouch","onuntouching"
                uniqpush(@touchingListeners,receiver)
            when "ontick"
                uniqpush(@tickListeners,receiver)
            when "onkey"
                uniqpush(@keyListeners,receiver)
            when "onjoy"
                uniqpush(@joyListeners,receiver)
            when "mouse"
                uniqpush(@mouseListeners,receiver)
            else
                return;
        end
        
    end

    def findBody(grp)
        if(grp.class==String)
            #puts grp
            return @nameToBody[grp]
        else
            return @groupToBody[grp.to_s]
        end
    end
    def createJoint(parent,child,type="ball",min=0,max=0,accel=0,damp=0,breakingForce=0)
        jnt=SP3xJointContext.new(parent,child,type,min,max,accel,damp,breakingForce)
        self.joints.push(jnt);
        return jnt
    end
        
    def createBody(grp,bodyPTR)
        body=SP3xBodyContext.new(self,grp,bodyPTR)

        @bodies.push(body)
        @groupToBody[grp.to_s]=body
        @nameToBody[grp.name]=body if(grp.name!="")

        return body
    end
    def destroyBody(body)
    end
    def connect(parent,child)
    end
    def camera()
        Sketchup.active_model.active_view.camera
    end
    def getUniqueID()
        @uniqueID=-1 if @uniqueID==nil
        @uniqueID+=1
        return @uniqueID
    end
    def initialize(model)
        @uniqueID=getUniqueID()
        @bodies=[]
        @joints=[]
        @touchingListeners=[]
        @tickListeners=[]
        @startListeners=[]
        @endListeners=[]
        @keyListeners=[]
        @joyListeners=[]
        @timerListeners=[]
        @mouseListeners=[]
        @deferedTasks=[]
        #lookups
        @groupToBody=Hash.new
        @nameToBody=Hash.new
        
        @frameRate=model.get_attribute("SPSETTINGS","framerate")
        @gravity=model.get_attribute("SPSETTINGS","gravity")
        if(model.attribute_dictionary("SPEvents")!=nil)
            model.attribute_dictionary("SPEvents").each{|k,v|
                _setEvent(k,v)
            }
        end
    end

    def _setEvent(name,script)
        eval("@#{name}=lambda{"+script+"}")    
    end    

end
class SP3xJointContext
    attr_accessor :name,:type
    #attr_reader :_jointPTR
    attr_reader :min,:max,:accel,:damp,:breakingForce
    attr_reader :desiredPosition,:desiredRotation
    attr_accessor :parent,:child
    def min=(v)
    end

    def setMin(v)
    end
    def disconnect()
            #defer the disconnect till end of frame
            #disconnect can cause crash if called
            #in ontouch
            @simulation.deferedTasks.push(lambda{
                self.disconnectNow
            }
        )
    end
    def disconnectNow()
        return if(!@connected||@_jointPTR==0)
        NewtonServer.destroyJoint(DL::PtrData.new(@_jointPTR))
        @child.joints.delete(self)
        @parent.joints.delete(self)
        @connected=false        
    end
    def setDesiredTransformation(xform)
        #return if(@type!="desired")
        NewtonServer.setDesiredMatrix(DL::PtrData.new(@_jointPTR),xform.to_a.pack("f*"))
        #extern "void setDesiredParams(DesiredJoint*,float*)"        
    end    
    
    def initialize(parent,child,type="ball",min=0,max=0,accel=0,damp=0,breakingForce=0)
        if(parent!=nil)
            parentBody=parent._bodyPTR
            xform=parent.group.transformation
        else
            parentBody=nil
            xform=Geom::Transformation.new #child.group.transformation
#xform=child.group.transformation
        end
        pinDir=xform.zaxis.to_a+xform.yaxis.to_a
        
        childBody=child._bodyPTR
        limits=[min,max,accel,damp,0,0,breakingForce]
        pos=xform.origin.to_a
    #pos=[0,0,0]
        jnt=NewtonServer.createJoint(type,pos.pack("f*"),
            pinDir.pack("f*"),
            childBody,parentBody, 
            limits.pack("f*") )	
            
            #todo. fix joints that return 0.
        #if(jnt!=0)
            @simulation=child.simulation
            @_jointPTR=jnt.to_i
            @connected=true
            @child=child
            @parent=parent
            @type=type
            parent.joints.push(self) if(parent!=nil)
            child.joints.push(self)
        #end
    end

end
class SP3xBodyContext
    #properties
    attr_accessor :name,:tag
    attr_accessor :velocity,:transformation,:rotation
    attr_accessor :ignore
    attr_accessor :frozen,:noautofreeze
    attr_reader :_bodyPTR
    attr_accessor :joints
    attr_accessor :valid

    #automatic set prop
    attr_reader :touchable#true=allow touch events
    attr_accessor :dragable
    attr_reader :simulation
    
    #events    
    attr_reader :onstart
    attr_reader :onend
    attr_reader :ontick
    attr_reader :onkey
    attr_reader :onmouse
    
    #attr_reader :ontouch
    #attr_reader :ontouching
    #attr_reader :onuntouch
    
    #used to calc touch and untouch.
    attr_reader :touchingBodies
    attr_reader :touchingBodiesLastFrame 
    
    def frame()
        return(@simulation.frame)    
    end
    def moveTo(pos,accel,damp)
    end
    def group()
        return @group    
    end
    def magnetic=(v)
        return if(@_bodyPTR==nil)
        @simulation.deferedTasks.push(lambda{
            if(v==true)
                NewtonServer.setBodyMagnetic(@_bodyPTR,1)
            else
                NewtonServer.setBodyMagnetic(@_bodyPTR,0)
            end
            })
    end
    def teleport(pos,recurse=true)
        deferedVelocity=getVelocity()
        deferedTorque=getTorque()
        @simulation.deferedTasks.push(lambda{
                setVelocity(deferedVelocity)
                setTorque(deferedTorque)
            })
        
        #convert to c bool.
        recurse=recurse ? 1:0
        if(pos.class==Geom::Transformation)
            NewtonServer.setMatrix(@_bodyPTR,pos.to_a.pack('f*'),recurse)    
        else
            NewtonServer.setMatrix(@_bodyPTR,Geom::Transformation.new(pos).to_a.pack('f*'),recurse)    
        end
    end
    def push(kick=nil)
        $sketchyPhysicsToolInstance.pushBody(group,kick) if kick!=nil        
    end    
    def nocollision=(v)
        return if(@_bodyPTR==nil)
        if(v==true)
            NewtonServer.setBodySolid(@_bodyPTR,0)
        else
            NewtonServer.setBodySolid(@_bodyPTR,1)
        end
    end
    def solid=(v)
        self.nocollision=!v
    end
    def static=(v)
    end    
    def destroy()
        return if(!@valid)
        
        NewtonServer.destroyBody(DL::PtrData.new(@_bodyPTR))
        @group.hidden=true;
        @valid=false
        @unhideAtEnd=true
        
    end
    def copy(pos=nil,lifetime=0)
        return nil if(group==nil)
        pos=Geom::Transformation.new(pos) if(pos!=nil)
        grp=$sketchyPhysicsToolInstance.copyBody(group,pos,lifetime)
        bdy=simulation.findBody(grp)
        return bdy
    end
    def position()
        return group.transformation.origin    
    end
    def getVelocity()
        velocity=[0.0,0.0,0.0].pack('f*').to_ptr
        NewtonServer.bodyGetVelocity(@_bodyPTR,velocity);
        return velocity.to_a("F3")
    end
    def setVelocity(velocity)
        NewtonServer.bodySetVelocity(@_bodyPTR,velocity.pack('f*'));
    end
   
    def setLinearDamping(damp)
        NewtonServer.bodySetLinearDamping(@_bodyPTR,damp)        
    end
    def setAngularDamping(damp)
        NewtonServer.bodySetAngularDamping(@_bodyPTR,damp.pack('f*'))        
    end
    def getTorque()
        torque=[0.0,0.0,0.0].pack('f*').to_ptr
        NewtonServer.bodyGetTorque(@_bodyPTR,torque);
        return torque.to_a("F3")
    end
    def setTorque(torque)
        NewtonServer.bodySetTorque(@_bodyPTR,torque.pack('f*'));
    end
    def transformation()
        return group.transformation    
    end
    def attach(child,breakingForce=0)
        connect(child,"fixed",0,0,0,0,breakingForce)        
    end
  
    def split(bdy=self,recurse=0)
        a,b=bdy.breakit(bdy.group)
        bdy.group.hidden=true
        @unhideAtEnd=true
        bdy.solid=false
        bdy.static=false#fix this.
        bdy.touchable=false
        @simulation.unsubscribeAll(bdy)

        $sketchyPhysicsToolInstance.newBody(a)
        $sketchyPhysicsToolInstance.newBody(b)
        ba=@simulation.findBody(a)
        ba.setVelocity(bdy.getVelocity)
        ba.setTorque(bdy.getTorque)
        bb=@simulation.findBody(b)
        bb.setVelocity(bdy.getVelocity)
        bb.setTorque(bdy.getTorque)
        ret=[]
        if(recurse>0)
            ret+=split(ba,recurse-1)
            ret+=split(bb,recurse-1)
        else
            ret=[ba,bb]    
        end
        return ret
    end
    def setDesired()
        return @simulation.createJoint(self,self)
    end
    def connect(child,type="ball",min=0,max=0,accel=0,damp=0,breakingForce=0)
        return @simulation.createJoint(self,child,type,min,max,accel,damp,breakingForce)
    end
    def handleTouching(toucher,force,pos)
            #return if already processed this collision.
        return if(@touchingBodies.include?(toucher))
        
        if(@ontouchFunc!=nil || @ontouchingFunc!=nil)
            if(@ontouchFunc!=nil &&!@touchingBodiesLastFrame.include?(toucher))
                @ontouchFunc.call(toucher,force,pos)
                #puts @touchingBodiesLastFrame.length
            end
            @touchingBodies.push(toucher)
        end
        if(@ontouchingFunc!=nil)
            @ontouchingFunc.call(toucher)
        end
    end
    def handleUntouching()
        uc=0
        if(@onuntouchFunc!=nil)
            untouched=@touchingBodiesLastFrame-@touchingBodies;
            
    #insure only one call per object. 
    #Should not be needed, but safer during develpment.
            untouched.uniq!
    #########################        
            
            if(untouched.length>0)
                uc+=1
                #puts "untouching "+untouched.length.to_s
            end
            untouched.each{|toucher|
                @onuntouchFunc.call(toucher)
            }
        end
        #puts [@touchingBodiesLastFrame.length,@touchingBodies.length,uc].inspect
        
        @touchingBodiesLastFrame=@touchingBodies
        @touchingBodies=[]
    end

    def _getBinding()
        binding    
    end
        #Needs to be private. do not use public. unexpected results.
    def touchable=(flag)
        @touchable=flag
        #puts "here"
        #puts flag
        if(flag)
            @simulation.subscribeToEvent("ontouching",self)
            @touchingBodies=[]
            @touchingBodiesLastFrame=[]
            NewtonServer.bodySetMaterial(@_bodyPTR,1)
            NewtonServer.setBodyCollideCallback(@_bodyPTR,NewtonServer::COLLIDE_CALLBACK)
        end
    end
    def ontouching(&_block)
        eval("@ontouchingFunc=_block")
        self.touchable=true
    end        
    def onuntouch(&_block)
        eval("@onuntouchFunc=_block")
        self.touchable=true
    end        
    def ontouch(&_block)
        eval("@ontouchFunc=_block")
        self.touchable=true
    end    
    def onstart(&_block)
        eval("@onstartFunc=_block")
        @simulation.subscribeToEvent("onstart",self)
    end    
    def onend(&_block)
        eval("@onendFunc=_block")
        @simulation.subscribeToEvent("onend",self)
    end    
    def ontick(&_block)
        eval("@ontickFunc=_block")
        @simulation.subscribeToEvent("ontick",self)
    end    
    def onclick(&_block)
        eval("@onclickFunc=_block")
        @simulation.subscribeToEvent("mouse",self)
    end       
    def onunclick(&_block)
        eval("@onunclickFunc=_block")
        @simulation.subscribeToEvent("mouse",self)
    end 
    def ondrag(&_block)
        eval("@ondragFunc=_block")
        @simulation.subscribeToEvent("mouse",self)
    end      
    def doOnStart()
        if(@onstartFunc!=nil)
            @onstartFunc.call()
        end
    end
    def doOnClick()
        if(@onclickFunc!=nil)
            @onclickFunc.call()
        end
    end    
    def doOnDrag()
        if(@ondragFunc!=nil)
            @ondragFunc.call()
        end
    end      
    def doOnUnClick()
        if(@onunclickFunc!=nil)
            @onunclickFunc.call()
        end
    end      
    def doOnEnd()
        if(@onendFunc!=nil)
            @onendFunc.call()
        end
        if(@unhideAtEnd==true)
            @group.hidden=false
        end
    end
    def doOnTick()
        if(@ontickFunc!=nil)
            @ontickFunc.call()
        end
    end
    
    
    def doMouse(type,x,y)
        case type
            when :click
                @onclickFunc.call(x,y) if @onclickFunc!=nil
            when :drag
                @ondragFunc.call(x,y) if @ondragFunc!=nil
            when :unclick
                @onunclickFunc.call(x,y) if @onunclickFunc!=nil
            when :doubleclick
                @ondoubleclickFunc.call(x,y) if @ondoubleclickFunc!=nil
            end
    end                    
                    
    def setEvent(_eventName,&_block)
        _eventName.downcase!
        eval("@#{_eventName}Func=_block")

        @simulation.subscribeToEvent(_eventName,self)
        case _eventName
            when "ontouching","ontouch","onuntouching"
                self.touchable=true
        end        
    end
    
    def _setEvent(_eventName,_script)
        _eventName.downcase!
        eval("@#{_eventName}Func=lambda{"+_script+"}")
        @simulation.subscribeToEvent(_eventName,self)
        case _eventName
            when "ontouching","ontouch","onuntouching"
                self.touchable=true
        end        
    end
    def initEvents(___events_grp)
        #$SAFE = 1
        
        begin
        #puts ___events_grp.get_attribute("SPOBJ","script").to_s
        #raise
            puts eval(___events_grp.get_attribute("SPOBJ","script").to_s)
        #puts "out"
        rescue StandardError,SyntaxError, NameError => e
            raise "Error in Script:\n"+___events_grp.get_attribute("SPOBJ","script").to_s+"\n"+$!
            #puts "Error:"+$!
            #raise
            next  
        end        
    end
    def initialize(sim,grp,bodyPTR)
        @simulation=sim
        @group=grp
        @_bodyPTR=bodyPTR
        name=grp.name if(name==nil)
        @name=name
        @joints=[]
        @uniqueID=@simulation.getUniqueID()
        
        @dragable=true
        @valid=true
        @unhideAtEnd=false
        
       
        #_setEvent("ontouch","puts @name+' touched'")
        #_setEvent("ontouching","puts @name+' touching'")
        #_setEvent("onuntouch","puts @name+' untouched'")
        #_setEvent("ontick","puts @name+' ticked'")
        #_setEvent("onstart","puts @name+' start'")
        #_setEvent("onend","puts @name+' end'")
        #eval("setEvent('onend'){puts group;puts 321}")
        
        initEvents(grp)
        
        if(grp.attribute_dictionary("SPEvents")!=nil)
            grp.attribute_dictionary("SPEvents").each{|k,v|
                _setEvent(k,v)
            }
        end    
    end
   
    
    def log(str)
        @simulation.deferedTasks.push(lambda{
            MSketchyPhysics3::logPhysicsMessage(str)
        })
    end
    #~ def ontouch(&block)
        #~ if(block==nil&& @ontouch!=nil);
            #~ @ontouch.call
        #~ else
            #~ @ontouch=block;
        #~ end
    #~ end

    #ontouch={
    #   bdy=simulation.createBody(touching.group)
    #   bdy.position=[0,0,100]
    #   bdy.ontouch={puts "ouch"}
    # ..or...
    #   touching.copy([0,0,100]).ontouch={puts "ouch"}
    #}

    #Thread.start {$SAFE=0;puts $SAFE;f=File.open("c:/temp/log.txt".taint);puts f}

    #b.setEvent("ontouch",'puts @name')

    
    #ontouch={
    #   touching.copy([0,0,100]).ontouch={puts "ouch"}}

    #Thread.start {$SAFE=0;puts $SAFE;f=File.open("c:/temp/log.txt".taint);puts f}

    ####################
    def delete_ents_behind_plane(ents,t1,plane)

        #ents=get_entities(first)
        delete=[]
        ents.each {|e|
            if e.class==Sketchup::Face && e.valid?
                mesh=e.mesh
                mesh.transform!(t1)  #transform face to global coordinates
                p1=mesh.point_at(1)
                p2=mesh.point_at(2)
                p3=mesh.point_at(3)
                cent=[(p1.x+p2.x+p3.x)/3.0,(p1.y+p2.y+p3.y)/3.0,(p1.z+p2.z+p3.z)/3.0]
                result=plane[0]*cent.x+plane[1]*cent.y+plane[2]*cent.z+plane[3]
                delete.push(e) if result<0.0
            elsif e.class==Sketchup::Edge && e.valid?
                p1=e.start.position
                p2=e.end.position
                p1=p1.transform(t1)
                p2=p2.transform(t1)
                cent=[(p1.x+p2.x)/2.0,(p1.y+p2.y)/2.0,(p1.z+p2.z)/2.0]
                result=plane[0]*cent.x+plane[1]*cent.y+plane[2]*cent.z+plane[3]
                delete.push(e) if result<0.0 and cent.distance_to_plane(plane)>0.001
                #delete.push(e) if cent.distance_to_plane(plane)>0.1
            end
        }

        ents.erase_entities(delete)  #delete the entities behind tha plane

    end


    def breakit(grp)
    #Sketchup.active_model.active_entities.add_group(Sketchup.active_model.selection)

        cutGroup=Sketchup.active_model.active_entities.add_group
        xlate=Geom::Transformation.new(grp.bounds.center)
        rot=xlate*Geom::Transformation.rotation([0,0,0],[rand-0.5,rand-0.5,rand-0.5],(rand-0.5)*10.0)
        f=cutGroup.entities.add_face(
            [-1000,-1000,0].transform!(rot),
            [1000,-1000,0].transform!(rot),
            [1000,1000,0].transform!(rot),
            [-1000,1000,0].transform!(rot))

        #xform=Geom::Transformation.rotation(grp.transformation.origin,[rand-0.5,rand-0.5,rand-0.5],(rand-0.5)*10.0)
        #xform=xform*Geom::Transformation.new(grp.bounds.center)#,[rand-0.5,rand-0.5,rand-0.5],(rand-0.5)*10.0)

        #cutGroup.transform!(xform)
        agrp=Sketchup.active_model.entities.add_instance(grp.definition,grp.transformation)
        agrp=agrp.make_unique
        agrp.set_attribute("SPOBJ","shape","convexhull")
        #agrp=grp.copy
        edges=agrp.entities.intersect_with(false,agrp.transformation,agrp.entities,agrp.transformation,false,[cutGroup])
        delete_ents_behind_plane(agrp.entities,agrp.transformation,f.plane)
        edges.each {|e| e.find_faces if(e.valid?)}

        bgrp=grp
        bgrp=Sketchup.active_model.entities.add_instance(grp.definition,grp.transformation)
        bgrp.make_unique
        bgrp.set_attribute("SPOBJ","shape","convexhull")
        p=f.plane
        p[0]=p[0]*-1.0
        p[1]=p[1]*-1.0
        p[2]=p[2]*-1.0
        p[3]=p[3]*-1.0
        edges=bgrp.entities.intersect_with(false,bgrp.transformation,bgrp.entities,agrp.transformation,false,[cutGroup])
        delete_ents_behind_plane(bgrp.entities,agrp.transformation,p)
        edges.each {|e| e.find_faces if(e.valid?)}

        #grp.hidden=true
        cutGroup.erase!
        
        return agrp,bgrp
    end

end





class SP3xControllerContext<  ControllerContext
    
    
    class Sketchup::Group
        def magnetic=(v)
            return if($sketchyPhysicsToolInstance==nil)
            body=DL::PtrData.new(self.get_attribute("SPOBJ","body",nil))
            return if body==nil
            if(v==true)
                NewtonServer.setBodyMagnetic(body,1)
            else
                NewtonServer.setBodyMagnetic(body,0)
            end
        end
        def copy(pos=nil,lifetime=0)
            return nil if($sketchyPhysicsToolInstance==nil)
            
            #body=DL::PtrData.new(self.get_attribute("SPOBJ","body",nil))
            #return nil if body==nil
            pos=Geom::Transformation.new(pos) if(pos!=nil)
            grp=$sketchyPhysicsToolInstance.copyBody(self,pos,lifetime)
            return grp
        end
    end


    def position()
        return[0,0,0] if($sketchyPhysicsToolInstance==nil)
        return $curEvalGroup.transformation.origin.to_a    
    end

    def setAnimation(name,frame)
        return if($sketchyPhysicsToolInstance==nil || $curEvalGroup==nil)
        for ent in $curEvalGroup.definition.entities
            if ent.definition.name == name+("%02d"%frame)
                ent.hidden = false
            else
                ent.hidden = true
            end
        end
    end 
    def touching()
        $curEvalTouchingGroup
    end
    def this()
        $curEvalGroup
    end
    def attach(child,breakingForce=0)
        connect(child,"fixed",0,0,0,0,breakingForce)        
    end
    def setMagnetic(v,grp=$curEvalGroup)
        return if($sketchyPhysicsToolInstance==nil || $curEvalGroup==nil)
        #grp=$curEvalGroup
        body=DL::PtrData.new(grp.get_attribute("SPOBJ","body",nil))
        if(v==true)
            NewtonServer.setBodyMagnetic(body,1)
        else
            NewtonServer.setBodyMagnetic(body,0)
        end
    end
    def connect(child,type="ball",min=0,max=0,accel=0,damp=0,breakingForce=0)
        return if($sketchyPhysicsToolInstance==nil)
        parent=$curEvalGroup
        xform=parent.transformation
        pinDir=xform.zaxis.to_a+xform.yaxis.to_a
        parentBody=DL::PtrData.new(parent.get_attribute("SPOBJ","body",nil))
        childBody=DL::PtrData.new(child.get_attribute("SPOBJ","body",nil))
        limits=[min,max,accel,damp,0,0,breakingForce]
        jnt=NewtonServer.createJoint(type,xform.origin.to_a.pack("f*"),
            pinDir.pack("f*"),
            childBody,parentBody, 
            limits.pack("f*") )	
    end

    
end

	



end#module